import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class BlockUnblockTransactionService {
  constructor(private http: HttpClient) {}

  getCountry() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/country?G_UserID=0&G_Agent_ID=0&Agent_Country_ID=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgent(CountryID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/agent?AgentID=0&CountryID=${CountryID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentBranch(AgentID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/agent-branch?AgentID=${AgentID}&SendBranchID=-1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getStatus(AgentType: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/status?AgentType=${AgentType}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDataByDate(
    FromDate: any,
    ToDate: any,
    AgentID: any,
    StatusID: any,
    AgentBranch: any,
    AgentBranchID: any
  ) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/by-date-all-record?FromDate=${FromDate}&ToDate=${ToDate}&AgentID=${AgentID}&StatusID=${StatusID}&AgentBranch=${AgentBranch}&AgentBranchID=${AgentBranchID}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getDatabyTransactionNo(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/by-transaction-no-all-record`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getLog(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/log?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  View(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/transaction-status-for-agent/view?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  block(TransactionNumber: any) {
    return this.http.post(
      `${
        environment.apiUrl
      }/api/transaction/transaction-status-for-agent/block?TransactionNumber=${TransactionNumber}&G_UserID=${getCacheData(
        'G_UserID'
      )}`,
      {},
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  unblock(TransactionNumber: any) {
    return this.http.post(
      `${
        environment.apiUrl
      }/api/transaction/transaction-status-for-agent/un-block?TransactionNumber=${TransactionNumber}&G_UserID=${getCacheData(
        'G_UserID'
      )}`,
      {},
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
