import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class EditBeneficiaryRegistrationService {
  constructor(private http: HttpClient) {}

  getCustomer(CustomerNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/edit-beneficiary-registration/search-customer?CustomerNumber=${CustomerNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  viewCustomer(ID: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/edit-beneficiary-registration/view?ID=${ID}&ModuleID=286`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  edit(BeneficiaryNo: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/edit-beneficiary-registration/edit?BeneficiaryNo=${BeneficiaryNo}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCurrency(CountryCode: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/payout-currency-list?CountryCode=${CountryCode}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPhoneCode() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/phone-country-code-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getPurposeOfTransfer() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/purpose-transfer-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getIdType() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/id-type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getSourceOfFund() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/source-of-found-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAccountTypeList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/account-type-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getRelationship() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/customer-relation-list`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  update(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/api/transaction-management/edit-beneficiary-registration/update`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getBankDetail(countryCode: any = 0, bankName = '', branchName = '') {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/beneficiary-registration/bank-detail?CountryCode=${countryCode}&BankName=${bankName}&BranchName=${branchName}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
