import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class EditTransactionDetailsService {
  constructor(private http: HttpClient) { }

  getCustomerNationality() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/edit-transaction-detail/customer-nationality`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getBeneficiaryNationality() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/edit-transaction-detail/beneficiary-nationality`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getCustomerByTrnNo(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction/edit-transaction-detail/all-record?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  Edit(payload: any) {
    return this.http.patch(
      `${environment.apiUrl}/api/transaction/edit-transaction-detail/edit`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  searchBankDetail(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/master/transaction/edit-transaction/search-bank-code`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
