import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class AllReceiveReportService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getReceiveCountryData(userId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/all-receive-trxn-report/rec-country?G_UserID=${userId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getReceiveAgentData(countryId: any) {
    return this.http.get(
      `${environment.apiUrl}/api/master/reports/all-receive-trxn-report/agent?CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  fillGridAllReceiveTrxnReportDetail(data: any) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/all-receive-trxn-report/detail/grid?gridRequestte=1`,
      data,
      {
        headers: this.getHeaders(),
      }
    );
  }
  fillGridAllReceiveTrxnReportSummary(data: any) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/all-receive-trxn-report/summary/grid?gridRequestte=1`,
      data,
      {
        headers: this.getHeaders(),
      }
    );
  }
  fillGridStatusWiseSummaryAllReceiveTrxnReport(data: any) {
    return this.http.post(
      `${environment.apiUrl}/api/master/reports/all-receive-trxn-report/status-wise-summary/grid?gridRequestte=1`,
      data,
      {
        headers: this.getHeaders(),
      }
    );
  }

  private getHeaders() {
    return new HttpHeaders({
      Authorization: getCacheData('admin_token'),
      Accept: 'application/json',
      username: getCacheData('username'),
    });
  }

  
}
