import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';

import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root',
})
export class DataMappingService {
  url = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getMappingType(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      IsActive: IsActive || 0,
    };

    return this.http.post(
      `${environment.apiUrl}/api/master/mapping-type-list`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getMappingAgentList(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      IsActive: IsActive || 0,
    };
    return this.http.post(
      `${environment.apiUrl}/api/master/mapping-send-agent-list`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
  getMappingAgentListSnd(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      IsActive: IsActive || 0,
    };
    return this.http.post(
      `${environment.apiUrl}/api/master/mapping-agent-list`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getMappingTritem(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      IsActive: IsActive || 0,
    };

    return this.http.post(
      `${environment.apiUrl}/api/master/mapping-tritem-list`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getMappingpayout(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      IsActive: IsActive || 0,
    };

    return this.http.post(
      `${environment.apiUrl}/api/master/mapping-payout-item-agent-list`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getfillgrid(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      IsActive: IsActive || 9,
    };

    return this.http.post(
      `${environment.apiUrl}/api/master/mapping-fill-grid`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  insertData(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    if (IsActive == 1) {
      IsActive = "true";
    }
    const payload = {
      Mode: 1,
      ActionType: ActionType || 1,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      UserID: getCacheData('G_UserID'),
      IsActive: IsActive || 9,
    };

    return this.http.post(
      `${environment.apiUrl}/api/master/insert-data-mapping`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  updateData(
    ActionType: any,
    PayoutAgentID: any,
    SendAgentID: any,
    id: any,
    TrValueID: any,
    PayoutValueID: any,
    IsActive: any
  ) {
    const payload = {
      Mode: 2,
      ActionType: ActionType || 1,
      ID: id,
      PayoutAgentID: PayoutAgentID || 0,
      SendAgentID: SendAgentID || 0,
      TrValueID: TrValueID || 0,
      PayoutValueID: PayoutValueID || 0,
      UserID: getCacheData('G_UserID'),
      IsActive: IsActive || 9,
    };

    return this.http.patch(
      `${environment.apiUrl}/api/master/update-data-mapping`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  deleteMapping(ActionType: number, ID: number) {
    const payload = {
      Mode: 10,
      ActionType,
      ID,
      UserID: getCacheData('G_UserID'),
    };

    return this.http.request(
      'delete',
      `${
        environment.apiUrl
      }/api/master/delete-data-mapping?Mode=10&ActionType=${ActionType}&ID=${ID}&UserID=${getCacheData(
        'G_UserID'
      )}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          'Content-Type': 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
