import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class InstantCashTransactionsService {

  url = environment.apiUrl;

  constructor(private http: HttpClient) {}


  getInstantCashDetails(fromDate: any, toDate: any, ICNumber: any) {
    let url = `${environment.apiUrl}/api/master/reports/rpt-instant-cash-details-list?FromDate=${fromDate}&ToDate=${toDate}`;

    if (ICNumber) {
      url += `&ICNumber=${ICNumber}`;
    }

    return this.http.get(url, {
      headers: {
        Authorization: getCacheData('admin_token'),
        Accept: 'application/json',
        username: getCacheData('username'),
      },
    });
  }
}
