import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { getCacheData } from '../utils/helper';

@Injectable({
  providedIn: 'root'
})
export class PayoutSummaryService {

  private baseUrl = environment.apiUrl;

  constructor(private http: HttpClient) {}

  getAgentPayoutSummaryGrid(agentId: any, branchId: any, fromDate: any, toDate: any): Observable<any> {
    return this.http.get(
      `${this.baseUrl}/api/master/reports/agent-payout-summary-report/grid?AgentID=${agentId}&BranchID=${branchId}&FromDate=${fromDate}&ToDate=${toDate}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentPayoutSummaryBranch(agentId: any, gAgentId: any, agentBranchId: any): Observable<any> {
    return this.http.get(
      `${this.baseUrl}/api/master/reports/agent-payout-summary-report/branch?AgentID=${agentId}&G_Agent_ID=${gAgentId}&Agent_Branch_ID=${agentBranchId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentPayoutSummaryAgent(agentId: any): Observable<any> {
    return this.http.get(
      `${this.baseUrl}/api/master/reports/agent-payout-summary-report/agent?G_Agent_ID=${agentId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
