import { Component } from '@angular/core';
import { TransactionAmendmentService } from '../transaction-amendment.service';
import { ToastrService } from 'ngx-toastr';

@Component({
  selector: 'app-transaction-amendment',
  templateUrl: './transaction-amendment.component.html',
  styleUrls: ['./transaction-amendment.component.css'],
})
export class TransactionAmendmentComponent {
  allData: any = '';
  TransactionNumber: any;

  constructor(
    private TransactionAmendmentSvc: TransactionAmendmentService,
    private toastrSvc: ToastrService
  ) {}

  searchByTransactionNumber() {
    if (!this.TransactionNumber) {
      alert('Please Enter Transaction No.');
      return;
    }
    this.TransactionAmendmentSvc.getDataByTransactionNumber(
      String(this.TransactionNumber)
    ).subscribe({
      next: (res: any) => {
        if (res?.length == 0) {
          alert('No data found.');
          return;
        }
        this.allData = res[0];
      },
      error: (err: any) => {
        // alert(err?.error?.message);
        this.toastrSvc.error(err?.error?.message);
      },
      complete: () => {},
    });
  }

  amend() {
    const payload = {
      TransactionNumber: this.allData?.TransactionNumber,
      MGRefNumber: this.allData?.MTORefNumber,
      BeneficiaryFirstName: this.allData?.Beneficiary_Name_F,
      BeneficiaryMiddleName: this.allData?.Beneficiary_Name_M,
      BeneficiaryLastName: this.allData?.Beneficiary_Name_L,
    };

    this.TransactionAmendmentSvc.Amend(payload).subscribe({
      next: (res: any) => {},
      error: (err: any) => {
        this.toastrSvc.error(err?.error?.message);
      },
      complete: () => {},
    });
  }
  toggleSideBar() {
    const bodyElement = document.body;
    bodyElement.classList.toggle('sidebar-collapsein');
  }
}
