import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';
import { HttpClient } from '@angular/common/http';

@Injectable({
  providedIn: 'root',
})
export class UploadTransactionsFileService {
  constructor(private http: HttpClient) {}

  getUploadTransactionFile(searchText: any = 0, searchType: any = -1) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-upload-file/all-record?searchText=${searchText}&SearchType=${searchType}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  uploadTransaction(formData: FormData) {
    return this.http.post(
      `${
        environment.apiUrl
      }/api/transaction-management/transaction-upload-file/upload-file?G_UserName=${getCacheData(
        'username'
      )}&G_UserID=1`,
      formData,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
