import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { environment } from 'src/environments/environment';
import { getCacheData } from './utils/helper';

@Injectable({
  providedIn: 'root',
})
export class ViewTransactionStatusForAgentService {
  constructor(private http: HttpClient) {}

  getCountryList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-status/country-list?UserId=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentList(countryId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-status/agent-list?StrFlag=1&AgentID=0&CountryID=${countryId}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getAgentBranchList(agentId: any = 0) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-status/agent-branch-list?StrFlag=4&AgentID=${agentId}&BranchID=-1`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getStatusList() {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-status/status?AgentType=0`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getTransactionReport(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-cancel-paid/transaction-report?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  getLog(TransactionNumber: any) {
    return this.http.get(
      `${environment.apiUrl}/api/transaction-management/transaction-status/log?TransactionNumber=${TransactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  transactionDetail(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/transaction-status/transaction-detail`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  transactionNumberDetail(payload: any) {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/transaction-status/transaction-number-detail`,
      payload,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }

  transactionReport(transactionNumber: any = '') {
    return this.http.post(
      `${environment.apiUrl}/api/transaction-management/transaction-cancel-paid/transaction-report?TransactionNumber=${transactionNumber}`,
      {
        headers: {
          Authorization: getCacheData('admin_token'),
          Accept: 'application/json',
          username: getCacheData('username'),
        },
      }
    );
  }
}
